#include "Collection.h"

CCollection::CCollection()
{
	int c = 16384;
	while(c--)
		Keys[c] = NULL;
	Contained = 0;
}

void CCollection::FreeMemory()
{
	int c = 16384;
	while(c--)
	{
		while(Keys[c])
		{
			CContainer *Next = Keys[c]->Next;
			delete Keys[c];
			Keys[c] = Next;
		}
	}
}

CCollection::~CCollection()
{
	FreeMemory();
}


void CCollection::Add(CEntity *New)
{
	Uint16 Pocket = New->GetHash();
	CContainer **S = &Keys[Pocket];
	while(*S && *New >= *(*S)->Content) S = &(*S)->Next;

	CContainer *Nxt = *S;
	*S = new CContainer;
	(*S)->Content = New;
	(*S)->Next = Nxt;

	Contained++;
}

void CCollection::Remove(CEntity *New)
{
	/* searches for actual pointer */
	Uint16 Pocket = New->GetHash();
	CContainer **S = &Keys[Pocket];
	while(*S && (*S)->Content != New) S = &(*S)->Next;

	CContainer *T = *S;
	*S = (*S)->Next;
	delete T;
	Contained--;
}

CEntity *CCollection::Find(CEntity &NS)
{
	Uint16 Pocket = NS.GetHash();
	CContainer **S = &Keys[Pocket];
	while(*S && *(*S)->Content >= NS)
	{
		if(*(*S)->Content == NS) return (*S)->Content;
		S = &(*S)->Next;
	}
	return NULL;
}

CEntity *CCollection::FindFirst()
{
	IteratePocket = 0;
	while(!Keys[IteratePocket] && IteratePocket < 16384) IteratePocket++;

	if(IteratePocket == 16384) return NULL;
	IterateKey = Keys[IteratePocket];
	return IterateKey->Content;
}

CEntity *CCollection::FindNext()
{
	if(IterateKey = IterateKey->Next) return IterateKey->Content;
	IteratePocket++;
	while(!Keys[IteratePocket] && IteratePocket < 16384) IteratePocket++;

	if(IteratePocket == 16384) return NULL;
	IterateKey = Keys[IteratePocket];
	return IterateKey->Content;
}

void CCollection::DeleteAll()
{
	CEntity *P = FindFirst();
	while(P)
	{
		delete P;
		P = FindNext();
	}
	FreeMemory();
}
