#ifndef __COLLECTION_H
#define __COLLECTION_H

#include "SDL.h"

class CCollection;

class CEntity
{
	public:
		virtual Uint16 GetHash() = 0; /* should return a 14 bit value */
		virtual bool operator >= (class CEntity &r) = 0;
		virtual bool operator == (class CEntity &r) = 0;
		virtual ~CEntity() {};
};

class CContainer
{
	public:
		CContainer() {Next = NULL;}
		CEntity *Content;
		CContainer *Next;
};

class CCollection
{
	public:
		CCollection();
		~CCollection();

		void Add(CEntity *);
		void Remove(CEntity *);
		inline int GetLength(){return Contained;}

		void DeleteAll();

		CEntity *Find(CEntity &);
		CEntity *FindFirst();
		CEntity *FindNext();

	private:
		CContainer *Keys[16384];
		int Contained;

		Uint16 IteratePocket;
		CContainer *IterateKey;
		void FreeMemory();
};

#endif
