#include "SystemDriver.h"
#include "GLFoundation.h"
#include "PString.h"
#include "Object.h"
#include "HostMachine.h"
#include <unistd.h>
#include "Material.h"

int main(int argc, char *argv[])
{
	//init system
	SetupHostMachine();
	SystemDriver = new CSystemDriver;
	
	CPString Path;
	Path = GetResourcePath();
	Path.CompletePath();
	Path += "models/";
//	Path += "models/got3d/";
	CPString Name;
	Name = "46.3ds";
//	Name ="Got3d-Low-Polygon-Tree-Demo.3DS";

	bool FullScr = false;
	GLFoundation.SetMode(640, 480, false);
	float zang = 0, xang = 0, zpos = 32;

	CObject TObject;
	TObject.Open(Path, Name);
	bool ScrChange = false;

	while(!SystemDriver->QuitRequested())
	{
		GLFoundation.Flip();
		bool Resize = SystemDriver->Resized();
		int W = SystemDriver->NewWidth(), H = SystemDriver->NewHeight();

		const Uint8 *Keys = SystemDriver->GetKeyState();

		if(Keys[SDLK_RETURN])
		{
			if(!ScrChange)
			{
				FullScr = !FullScr; Resize = true;
				ScrChange = true;
			}
		}
		else
			ScrChange = false;

		if(Resize)
		{
			CMaterial *Mat = (CMaterial *)MaterialCollection.FindFirst();
			while(Mat)
			{
				Mat->Backup();
				Mat = (CMaterial *)MaterialCollection.FindNext();
			}

			GLFoundation.SetMode(W, H, FullScr);

			Mat = (CMaterial *)MaterialCollection.FindFirst();
			while(Mat)
			{
				Mat->Restore();
				Mat = (CMaterial *)MaterialCollection.FindNext();
			}
		}

		glPushMatrix();

			glTranslatef(0, -16, zpos);
			glRotatef(zang, 0, 1, 0);
			glRotatef(xang, 1, 0, 0);

			if(Keys[SDLK_LEFT]) zang -= 0.2f;
			if(Keys[SDLK_RIGHT]) zang += 0.2f;
			if(Keys[SDLK_UP]) xang -= 0.2f;
			if(Keys[SDLK_DOWN]) xang += 0.2f;
			if(Keys[SDLK_z]) zpos -= 0.2f;
			if(Keys[SDLK_a]) zpos += 0.2f;

			TObject.DrawSolid();
			TObject.DrawTransparent();
		glPopMatrix();
	}

	MaterialCollection.DeleteAll();
	delete SystemDriver;

    return 0;
}
