#ifndef __MATERIAL_H
#define __MATERIAL_H

#include "PString.h"
#include "SDL_opengl.h"
#include "Collection.h"
#include <lib3ds/material.h>

/* inherits from PString as identified by name */
class CMaterial: public CPString
{
	public:
		CMaterial();
		~CMaterial();

		bool Setup(CPString &Path, Lib3dsMaterial *);
		void Select();

		/* this one queries whether this material involves any transparency */
		inline bool IsTransparent() {return FourChannel;}

		/* for preserving across graphics mode changes */
		void Backup();
		void Restore();

	private:
		GLuint TexEnv;
		GLfloat AmbientColour[4], DiffuseColour[4], SpecularColour[4];
		GLfloat Shininess;
		bool TwoSided;
		GLfloat Transparency;

		bool FourChannel;
		int Width, Height;
		Uint8 *BackupStore;
		bool CompressedBackup;

		static CMaterial *CurrentMaterial;
		void RestoreFromDisk();
		CPString MapName, OpacityName;
};

extern CCollection MaterialCollection;
extern CPString &GetMaterialName(Lib3dsMaterial *basemat);

#endif
