#ifndef __OBJECT_H
#define __OBJECT_H

#include "PString.h"
#include "SDL_opengl.h"
#include "Material.h"
#include "BSP.h"

/* inherits from PString as identified by name */
class CObject: public CPString
{
	public:
		CObject();
		~CObject();

		bool Open(CPString &Path, CPString &Name);
		void DrawSolid();
		void DrawTransparent();

	private:
		struct Mesh
		{
			GLfloat Matrix[16];

			GLfloat *Verts;
			int NumVerts;

			struct FaceSet
			{
				CMaterial *Material;
				GLenum Mode;
				GLuint *Faces;
				int NumFaces;
				FaceSet *Next;
			} *Faces;

			CBSP *Transparent;
			Mesh *Next;
		} *MeshList;
};

#endif
