#include "PString.h"
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <typeinfo>

#define ALLOC_SIZE 256

#ifndef stricmp
int stricmp(const char *string1, const char *string2)
{
	while(*string1 && *string2 && tolower(*string1) == tolower(*string2))
	{
		string1++;
		string2++;
	}

	if(!string1 && string2) return -1;
	if(string1 && !string2) return +1;
	if(!string1 && !string2) return 0;

	return tolower(*string2) - tolower(*string1);
}
#endif
CPString CPString::CPS__Output;

CPString::CPString()
{
	Contents = NULL;
	AllocdChars = 0;
}

CPString::~CPString()
{
	if(Contents) {free(Contents); Contents = NULL; AllocdChars = 0;}
}

Uint16 CPString::GetHash()
{
	if(!Contents) return 0;
	return ((Contents[0]&0x7f) << 7) | (Contents[1]&0x7f);
}

bool CPString::operator >= (class CEntity &tr)
{
	if(typeid(tr) != typeid(CPString)) return GetHash() >= tr.GetHash();
	CPString *r = dynamic_cast<CPString *>(&tr);

	if(!Contents && r->Contents) return false;
	if(Contents && !r->Contents) return true;
	if(!Contents && !r->Contents) return true;

	return stricmp(Contents, r->Contents) >= 0 ? true : false;
}

bool CPString::operator == (class CEntity &tr)
{
	if(typeid(tr) != typeid(CPString)) return GetHash() >= tr.GetHash();
	CPString *r = dynamic_cast<CPString *>(&tr);

	if(!Contents && r->Contents) return false;
	if(Contents && !r->Contents) return false;
	if(!Contents && !r->Contents) return true;

	return stricmp(Contents, r->Contents) ? false : true;
}

/*
	ASSIGNMENT
*/
CPString::CPString(const CPString &rhs)
{
	AllocdChars = strlen(rhs.Contents)+ALLOC_SIZE;
	Contents = (char *)malloc(AllocdChars);
	strcpy(Contents, rhs.Contents);
}

CPString::CPString(const char *rhs)
{
	AllocdChars = strlen(rhs)+ALLOC_SIZE;
	Contents = (char *)malloc(AllocdChars);
	strcpy(Contents, rhs);
}

class CPString &CPString::operator =(const char *carray)
{
	if(AllocdChars > strlen(carray) && AllocdChars <= strlen(carray)+ALLOC_SIZE)
	{
		strcpy(Contents, carray);
	}
	else
	{
		AllocdChars = strlen(carray)+ALLOC_SIZE;
		Contents = (char *)realloc(Contents, AllocdChars);
		strcpy(Contents, carray);
	}
	
	return *this;
}

class CPString &CPString::operator =(const CPString &r)
{
	return *this = r.Contents;
}

/*
	ADDITION
*/

class CPString &CPString::operator +(const char *carray)
{
	/* TODO: What if carray came from CPS__Output? */
	CPS__Output = *this;
	return CPS__Output += carray;
}

class CPString &CPString::operator +=(const char *carray)
{
	unsigned int newlen = Contents ? strlen(Contents) : 0;
	newlen += strlen(carray) + 1;
	
	if(AllocdChars < newlen || AllocdChars > newlen+ALLOC_SIZE)
	{
		AllocdChars = newlen+ALLOC_SIZE;

		if(Contents)
			Contents = (char *)realloc(Contents, newlen+ALLOC_SIZE);
		else
		{
			Contents = (char *)malloc(newlen+ALLOC_SIZE);
			Contents[0] = '\0';
		}
	}

	strcpy(&Contents[strlen(Contents)], carray);

	return *this;
}

class CPString &CPString::operator +(const CPString &r)
{
	return *this + r.Contents;
}

class CPString &CPString::operator +=(const CPString &r)
{
	return *this += r.Contents;
}

/*
	misc
*/
void CPString::StripEnding()
{
	if(!Contents) return;

	char *eptr = Contents + strlen(Contents) - 1;
	if(*eptr == '/') eptr--;

	while((eptr != Contents) && *eptr != '/') eptr--;
	eptr[0] = '/';
	eptr[1] = '\0';
}

void CPString::Output(FILE *target)
{
	if(!Contents) return;
	fputs(Contents, target);
}

void CPString::CompletePath()
{
	if(!Contents) return;
	if(Contents[strlen(Contents)-1] != '/') *this += "/";
}
