#ifndef __STRING_H
#define __STRING_H

#include "Collection.h"
#include <stdio.h>

class CPString: public CEntity
{
	public:
		CPString();
		~CPString();
		
		Uint16 GetHash();
		bool operator >= (class CEntity &r);
		bool operator == (class CEntity &r);

		/* copy constructors */
		CPString(const CPString &rhs);
		CPString(const char *rhs);

		/* assignment */
		class CPString &operator =(const char *carray);
		class CPString &operator =(const CPString &r);
		operator const char *() {return Contents;}

		/* addition */
		class CPString &operator +(const char *carray);
		class CPString &operator +=(const char *carray);

		class CPString &operator +(const CPString &r);
		class CPString &operator +=(const CPString &r);
		
		/* useful bits */
		void StripEnding();
		void Output(FILE *target = stdout);
		void CompletePath();

	private:
		char *Contents;
		unsigned int AllocdChars;
		static CPString CPS__Output;
};

class CPStringMapping: public CPString
{
	public: CPString AlternateName;
};

#endif
