#ifndef __SYSTEMDRIVER_H

#include "SDL.h"

class CSystemDriver
{
	public:
		~CSystemDriver();
		CSystemDriver();

		/* graphics mode, etc */
		bool SetMode(int w, int h, bool fullscreen);
		void Flip();

		/* input */
		const Uint8 *GetKeyState();
		int GetNumKeys();
		inline bool QuitRequested() {return Quit;}

		/* window resize */
		inline bool Resized() {return Resize;}
		inline int NewWidth() {return NewW;}
		inline int NewHeight() {return NewH;}

	private:
		SDL_Surface *Screen;
		bool Quit;

		bool Resize;
		int NewW, NewH;
};

extern CSystemDriver *SystemDriver;

#endif